--- old/usr/src/cmd/devprop/devprop.c	Mon May 23 09:02:06 2016
+++ new/usr/src/cmd/devprop/devprop.c	Mon May 23 09:02:06 2016
@@ -23,7 +23,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
 
 #include <stdio.h>
 #include <unistd.h>
@@ -50,7 +49,7 @@
 	uchar_t *val_b;
 	int *val_i;
 	int64_t *val_l;
-	char *val_s;
+	char *val_s, *ptr;
 	int n;
 
 	extern char *optarg;
@@ -73,7 +72,8 @@
 	while ((c = getopt(argc, argv, ":n:vqbils")) != -1) {
 		switch (c) {
 		case 'n':
-			path = optarg;
+			if ((path = realpath(optarg, NULL)) == NULL)
+				path = optarg;
 			break;
 		case ':':
 			usage();
@@ -108,9 +108,14 @@
 	 * "/devices", which we strip off here as di_init() expects
 	 * just the path to the node.
 	 */
-	if (strncmp("/devices/", path, strlen("/devices/")) == 0)
+	if (strncmp("/devices/", path, strlen("/devices/")) == 0) {
 		path += strlen("/devices");
 
+		/* cut off minor name */
+		if ((ptr = strrchr(path, ':')) != NULL)
+			*ptr = '\0';
+	}
+
 	if ((dn = di_init(path, DINFOPROP)) == DI_NODE_NIL) {
 		perror("di_init");
 		return (1);
